// 引入登录，登出，获取用户信息 函数
import { login, logout, getInfo } from '@/api/user'
// 引入获取token，设置token，移除token 函数
import { getToken, setToken, removeToken } from '@/utils/auth'
// 引入重置路由函数
import { resetRouter } from '@/router'

const getDefaultState = () => {
  return {
    token: getToken(),
    name: sessionStorage.getItem('name'),
    avatar: ''
  }
}

const state = getDefaultState()

const mutations = {
  // 重置用户信息为空
  RESET_STATE: (state) => {
    Object.assign(state, getDefaultState())
  },
  // 获取用户token存储在仓库
  SET_TOKEN: (state, token) => {
    state.token = token
  },
  // 获取用户昵称存储在仓库
  SET_NAME: (state, name) => {
    state.name = name
    sessionStorage.setItem('name', state.name)
  },
  // 获取用户头像存储在仓库
  SET_AVATAR: (state, avatar) => {
    state.avatar = avatar
  }
}

const actions = {
  // 用户登陆
  async login({ commit }, userInfo) {
    let res = await login(userInfo)
    // console.log(res);
    if (res.status==200) {
      commit('SET_TOKEN', res.data)
      // commit('SET_NAME', res.data.userName)
      setToken(res.data)
      // return 'ok'
    } else {
      // return Promise.reject(new Error('faile'))
      console.log("用户登陆失败");
    }
  },

  // 获取用户信息
  async getInfo({ commit, state }) {
    let res = await getInfo(state.token)
    // console.log(res);
    if (res.success) {
      const { data } = res
      if (!data) {
        return reject('验证失败，请重新登录')
      }
      const { name, avatar } = data
      commit('SET_NAME', name)
      commit('SET_AVATAR', avatar)
      // return 'ok'
    } else {
      console.log("获取用户信息失败");
    }
  },

  // 用户登出
  logout({ commit, state }) {
    // let res = await logout(state.token)
    // console.log(res);
    // if (res.success) {
    removeToken() // 必须先删除token
    sessionStorage.removeItem('name')
    resetRouter()
    commit('RESET_STATE')
    // } else {
    //   console.log("用户登出失败");
    // }
  },

  // 移除 token
  resetToken({ commit }) {
    return new Promise(resolve => {
      removeToken() // 必须先删除token
      commit('RESET_STATE')
      resolve()
    })
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}

